function createSelectionTable(seltabName, columns, maxcols) {
        try {
                //create global params, used in other functions
                comparisonTableName=seltabName;
                numcols=columns;
                maxcolumns=maxcols;
                var selTab=document.getElementById(seltabName);
                try {
                        var firstRow=selTab.rows[0];
                } catch (err) {
                        var placeHolder=document.getElementById('visibleselection');
                        placeHolder.innerHTML="Error. Please make sure this article contains table with id <b>comparisontable</b>";
                        return;
                }
                var placeHolder=document.getElementById('visibleselection');
                var origCheckBox=placeHolder.firstChild;

                var tbl     = document.createElement("table");
                var tblBody = document.createElement("tbody");

                var count=1;
                // creating all cells
                for (var j = 0; j < (firstRow.cells.length/maxcols); j++) {
                    // creates a table row
                    var row = document.createElement("tr");

                    for (var i = 0; i < maxcols; i++) {
                        var cell = document.createElement("td");
                        if (count<firstRow.cells.length) {
                                var checkbox = origCheckBox.cloneNode(true);
                                checkbox.id="col"+(count);
                                checkbox.checked=false;
                                var cell=firstRow.cells[count].cloneNode(true);
                                cell.insertBefore(checkbox,cell.firstChild);
                                row.appendChild(cell);
                                count++;
                        }
                    }

                    // add the row to the end of the table body
                    tblBody.appendChild(row);
                }

                // put the <tbody> in the <table>
                tbl.appendChild(tblBody);
                // appends <table> into <body>
                placeHolder.removeChild(placeHolder.firstChild);
                placeHolder.appendChild(tbl);
                init_comparison_table();
        } catch (err) {
                show_error_message();
        }
}

function show_hide_column(col_no,do_show) {
        try {
                if (count_checked()>(maxcolumns-1)) {
                        disableselection(true);
                } else {
                        disableselection(false);
                }
                var stl;
                if (do_show) stl = 'table-cell'
                else stl = 'none';

                var tbl  = document.getElementById(comparisonTableName);
                var rows = tbl.getElementsByTagName('tr');

                for (var row=0; row<rows.length;row++)
                {
                        var cels = rows[row].getElementsByTagName('td');
                        cels[col_no].style.display=stl;
                }
        } catch (err) {
                show_error_message();
        }
}

function show_error_message() {
                var errorDiv=document.createElement("h1");
                errorDiv.innerHTML="Comparison table plugin encountered error. Please report it to <a href='http://marguspala.com/comparison-table-plugin-for-joomla>http://marguspala.com/comparison-table-plugin-for-joomla</a>''";
                var errorReportUrl=document.createElement("a");
                errorReportUrl.innerHTML="http://marguspala.com/comparison-table-plugin-for-joomla";
                errorReportUrl.setAttribute("href","http://marguspala.com/comparison-table-plugin-for-joomla");
                errorDiv.appendChild(errorReportUrl);
                document.body.appendChild(errorDiv);
}

function disableselection(en){
        selectiontable=document.getElementById('visibleselection');
        checkboxes=selectiontable.getElementsByTagName('input');
        for (var i=0; i<checkboxes.length;i++) {
                if(checkboxes[i].checked==false) {
                        checkboxes[i].disabled=en;
                }
        }
}

function init_comparison_table(){
        selectiontable=document.getElementById('visibleselection');
        checkboxes=selectiontable.getElementsByTagName('input');
        for (var i=0; i<checkboxes.length;i++) {
                if(checkboxes[i].checked==true) {
                        show_hide_column(i+1, true);
                } else {
                        show_hide_column(i+1, false);
                }
        }
}

function count_checked() {
        selectiontable=document.getElementById('visibleselection');
        checkboxes=selectiontable.getElementsByTagName('input');
        count=0;
        for (var i=0; i<checkboxes.length;i++) {
                if(checkboxes[i].checked==true) {
                        count++;
                }
        }
        return count;
}

function isEmpty(str) {
    return (!str || 0 === str.length);
}

