<?php

/*------------------------------------------------------------------------
# Content - Comparison Table
# ------------------------------------------------------------------------
# author    Margus Pala
# copyright Copyright (C) 2011 Margus Pala. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.marguspala.com
# Technical Support:  Comments - http://marguspala.com/comparison-table-plugin-for-joomla/
-------------------------------------------------------------------------*/
     // no direct access
        defined( '_JEXEC' ) or die( 'Restricted access' );
        jimport( 'joomla.plugin.plugin' );

        class plgContentComparisontable extends JPlugin {

                public function __construct(& $subject, $config)
                {
                        parent::__construct($subject, $config);
                        $this->loadLanguage();
                }

		public function onPrepareContent( &$article, &$params, $limitstart = 0 )
		{
			$article->text = $this->modifyText($article->text);
		}
	 
		public function onContentPrepare($context, &$row, &$params, $page = 0)
		{
			// $row in Joomla! 1.6/1.7 may be a string, not an article object!
			if(is_object($row)) {
				return $this->onPrepareContent($row, $params, $page);
			} else {
				$row = $this->modifyText($row);
			}
			return true;
		}
	 
		private function modifyText($text)
		{
                        $table_id="comparisontable";
                        $columns=$this->params->get('num_cols');
                        $maxcomp=$this->params->get('max_cols');
                        $orig='/\{comparisontable\}/';
                        $replacement="<div id='visibleselection'><input type='checkbox' onclick='show_hide_column(this.id.substr(3,4),this.checked)'></input></div>";

			if(version_compare(JVERSION,'1.6.0','ge')) {
				$replacement.="<script language='javascript' src='". JURI::base( true ) ."/plugins/content/comparisontable/js/compare.js'></script>";
			} else {
				$replacement.="<script language='javascript' src='". JURI::base( true ) ."/plugins/content/js/compare.js'></script>";
			}

			$origarticle=$text;
                        $text = preg_replace($orig, $replacement, $text);

			if (strcmp ($origarticle, $text)!=0) {
				$text.="<script language='javascript'>createSelectionTable('".$table_id."',".$columns.",".$maxcomp.");</script>";
			}
			return $text;
		}
        }
?>

